#include <bits/stdc++.h>
using namespace std;

const long long MX=1e6+10;
const long long INF=1e18;

long long a1,a2,a3,ans=INF;
long long a[MX],pr[MX];
long long n;

int main()
{
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    cin>>n;

    int sm=0;
    for(long long i=1;i<=n;i++)
    {
        cin>>a[i];
        pr[i]=pr[i-1]+a[i];

        sm+=a[i];
    }

    if(sm<=1)
    {
        cout<<"0\n1 2 3\n";
        return 0;
    }

    if(sm==2)
    {
        for(int i=1;i<=n;i++)
        {
            if(a[i]==1)
            {
                cout<<"1\n1 "<<i<<" "<<i+1<<"\n";
                return 0;
            }
        }
    }

    int ob1=sm/3,i1;
    int ob2=sm/3+(sm%3==2),i2;

    for(int i=1;i<=n;i++)
    {
        if(pr[i]==ob1)
        {
            i1=i;
            break;
        }
    }

    for(int i=i1+1;i<=n;i++)
    {
        if(pr[i]-pr[i1]==ob2)
        {
            i2=i;
            break;
        }
    }

    cout<<(sm%3!=0)<<"\n"<<1<<" "<<i1+1<<" "<<i2+1<<"\n";
    return 0;
}
